﻿//////////////////////////////////////////////
// AtmosphereProgramTracker.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class Program ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../../Utils/ProgramTracker.h"

#include "AtmosphereEffectInfo.h"

// nkCommon
#include <nilkinsCommon/Patterns/SingletonClass.h>

/// Internals --------------------------------

namespace nkAstraeus
{
	struct AtmosphereProgramIdGenerator
	{
		static unsigned long long generate (const AtmosphereEffectInfo& info) ;
	} ;

	struct AtmosphereProgramNameGenerator
	{
		constexpr static const char* name = "NILKINS_ATMOSPHERE_PROGRAM_" ;
	} ;
}

/// Class ------------------------------------

namespace nkAstraeus
{
	class AtmosphereProgramTracker final : public ProgramTracker<AtmosphereEffectInfo, AtmosphereProgramIdGenerator, AtmosphereProgramNameGenerator>, public nkCommon::SingletonClass<AtmosphereProgramTracker>
	{
		friend class SingletonClass<AtmosphereProgramTracker> ;

		private :

			// Functions
			// Constructor, destructor
			AtmosphereProgramTracker () ;
			~AtmosphereProgramTracker () ;
	} ;
}