﻿//////////////////////////////////////////////
// LuaThread.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkScripts
{
	class Environment ;
	class Script ;
	class ScriptObjectReference ;
}

namespace nkTasks
{
	class Thread ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../Scheduler/LuaSchedulerTask.h"

// Standards
#include <memory>
#include <unordered_map>

/// Class ------------------------------------

namespace nkAstraeus::lua::nkTasksWrap
{
	class LuaThread final
	{
		private :

			// Thread nkTasks
			nkTasks::Thread* _thread ;
			// Environnement à part
			nkScripts::Environment* _env ;

			// Les références sur les tasks actives
			std::unordered_map<LuaSchedulerTask*, nkScripts::ScriptObjectReference> _taskRefs ;

		public :

			// Constructeur, destructeur
			LuaThread () ;
			~LuaThread () ;

			// Manipulations
			void addTask (std::unique_ptr<LuaSchedulerTask> task, const nkScripts::ScriptObjectReference& luaRef) ;
			void releaseTaskRef (LuaSchedulerTask* task) ;
			void run () ;

			// Utils
			void runScript (nkScripts::Script* script) ;
	} ;
}