﻿//////////////////////////////////////////////
// ShaderInstanceCustomSlot.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class Entity ;
}

/// Includes ---------------------------------

// nkGraphics
#include "../../Dll/DllDefines.h"

// nkMemory
#include <NilkinsMemory/Containers/String.h>
#include <NilkinsMemory/Containers/StringView.h>

// Standards
#include <string>

/// Class ------------------------------------

namespace nkGraphics
{
	class DLL_GRAPHICS_EXPORT ShaderInstanceCustomSlot
	{
		protected :
		
			// Attributs
			// Identification pour aider lors des imports / exports surtout
			nkMemory::String _typeName ;
			// Semantic name
			nkMemory::String _semanticName ;

		public :
	
			// Constructeur, destructeur
			ShaderInstanceCustomSlot () ;
			virtual ~ShaderInstanceCustomSlot () ;

			// Getters
			nkMemory::StringView getTypeName () const ;
			nkMemory::StringView getSemanticName () const ;

			// Setters
			void setSemanticName (const nkMemory::StringView& value) ;

			// Fonctions à refaire
			virtual unsigned int getDataByteSize () = 0 ;
			virtual void fillDataBuffer (Entity* caller, void* buffer) = 0 ;
	} ;
}
