﻿//////////////////////////////////////////////
// Static.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkWinUi
{
	struct ClickEventData ;
}

/// Includes ---------------------------------

// nkWinUi
#include "../Dll/DllDefines.h"

#include "../Enums/Alignment.h"

#include "Component.h"

// Standards
#include <functional>
	
/// Class ------------------------------------

namespace nkWinUi
{
	class DLL_WINUI_EXPORT Static : public Component
	{
		protected :
		
			// Attributs
			// For styling
			ALIGNMENT _alignHorizontal ;
			ALIGNMENT _alignVertical ;

			bool _wordWrap ;
		
		public :
		
			// Constructeur, destructeur
			Static (MainSystem* parentSystem) ;
			~Static () ;

			// Getters
			ALIGNMENT getAlignHorizontal () const ;
			ALIGNMENT getAlignVertical () const ;
			bool getWordWrap () const ;

			// Setters
			virtual void setAlignHorizontal (ALIGNMENT value) ;
			virtual void setAlignVertical (ALIGNMENT value) ;
			virtual void setWordWrap (bool value) ;

			// Import / Export
			virtual void exportIntrospection (nkExport::Node* rootNode) override ;
			virtual void importClassFromTree (nkExport::Node* rootNode) override ;
	} ;
}